//www.elegoo.com
//2016.12.9

#include "IRremote.h"

int receiver = 3; // Signal Pin of IR receiver
int led1 = 4;           // the PWM pin the LED is attached to
int led2 = 5;           // the PWM pin the LED is attached to
int led3 = 6;           // the PWM pin the LED is attached to
int led4 = 7;           // the PWM pin the LED is attached to
int led5 = 8;           // the PWM pin the LED is attached to
const int buttonPin = 9;     // the number of the pushbutton pin for ON/OFF


int led1on = 0; // Changes to remember state if not OFF
int led2on = 0;
int led3on = 0;
int led4on = 0;
int led5on = 0;
int leddiscoon = 0;
int ledallon = 3;
int aledon = 0;
int brightness = 255;
int buttonState = 1;

/*-----( Declare objects )-----*/
IRrecv irrecv(receiver);     // create instance of 'irrecv'
decode_results results;      // create instance of 'decode_results'

void setup()   /*----( SETUP: RUNS ONCE )----*/
{
  Serial.begin(9600);
  Serial.println("Ollie Rocket - IR Debug");
  irrecv.enableIRIn(); // Start the receiver
  pinMode(led1, OUTPUT);
  pinMode(led2, OUTPUT);
  pinMode(led3, OUTPUT);
  pinMode(led4, OUTPUT);
  pinMode(led5, OUTPUT);
  pinMode(buttonPin, INPUT_PULLUP);

}/*--(end setup )---*/

void loop()   /*----( LOOP: RUNS CONSTANTLY )----*/
{
  buttonState = digitalRead(buttonPin); // Checks state of on/off button
  
  if (irrecv.decode(&results)) {            // Receives IR codes and flip/flops on/off per command
    unsigned int value = results.value;
    Serial.println(results.value);
    switch (value) {

      case 0xFF30CF:                          // If IR code for button 1 received
        if (led1on == 1) {
          led1on = 0;
        } else {
          led1on = 1;
        }
        Serial.println("Button 1");
        Serial.println(brightness);
        break;

      case 0xFF18E7:                          // If IR code for button 2 received
        if (led2on == 1) {
          led2on = 0;
        } else {
          led2on = 1;
        }
        Serial.println("Button 2");
        Serial.println(brightness);
        break;

      case 0xFF7A85:                          // If IR code for button 3 received
        if (led3on == 1) {
          led3on = 0;
        } else {
          led3on = 1;
        }
        Serial.println("Button 3");
        Serial.println(brightness);
        break;

      case 0xFF10EF:                          // If IR code for button 4 received
        if (led4on == 1) {
          led4on = 0;
        } else {
          led4on = 1;
        }
        Serial.println("Button 4");
        Serial.println(brightness);
        break;

      case 0xFF38C7:                          // If IR code for button 5 received
        if (led5on == 1) {
          led5on = 0;
        } else {
          led5on = 1;
        }
        Serial.println("Button 5");
        Serial.println(brightness);
        break;
        
      case 0xFFB04F:                          // If IR code for button 5 received
        if (leddiscoon == 1) {
          leddiscoon = 0;
        } else {
          leddiscoon = 1;
        }
        Serial.println("Button 5");
        Serial.println(brightness);
        break;

      case 0xFF906F:                          // If IR code for button UP received
        if (brightness <= 216) {
          brightness = brightness + 40;
        } else {
          brightness = brightness;
        }
        Serial.println("UP");
        Serial.println(brightness);
        break;

      case 0xFFE01F:                          // If IR code for button DOWN received
        if (brightness >= 40) {
          brightness = brightness - 40;
        } else {
          brightness = brightness;
        }
        Serial.println("DOWN");
        Serial.println(brightness);
        break;

      case 0xFFA25D:
        if (ledallon == 1 || ledallon == 2 || aledon == 1) { // IF IR code for button POWER received
          ledallon = 0;
        } else {
          ledallon = 1;
        }
        Serial.println("POWER");
        Serial.println(brightness);
        break;
    }
    delay(50); // Do not get immediate repeat
    irrecv.resume(); // Receive the next value
  }

  // WHAT TO DO WHEN Button Pressed


  if ((buttonState == LOW) && ledallon == 3 ) { // If button pressed and lights off, turn the on
    ledallon = 1;
    Serial.println("Button press - ON");
  } 

  if ((buttonState == LOW) && (ledallon == 2) ) { // if button pressed and lights on, turn them off
    ledallon = 0;
    Serial.println("Button press - ON");
    } 


  // WHAT TO DO WHEN FLIP/FLOP on device received

  if (led1on == 1) {          // Check if led1on = 1, if so set led on, if not turn off.
    analogWrite(led1, brightness);           // and set its state as on
    aledon = 1;
  } else {                      // else set it off
    analogWrite(led1, 0);
  }

  if (led2on == 1) {     // If led 2 'ON'
    analogWrite(led2, brightness);
    aledon = 1;
  } else {
    analogWrite(led2, 0);
  }

  if (led3on == 1) {     // If led 3 'ON'
    analogWrite(led3, brightness);
    aledon = 1;
  } else {
    analogWrite(led3, 0);
  }

  if (led4on == 1) {     // If led 4 'ON'
    analogWrite(led4, brightness);
    aledon = 1;
  } else {
    analogWrite(led4, 0);
  }

  if (led5on == 1) {     // If led 5 'ON'
    analogWrite(led5, brightness);
    aledon = 1;
  } else {
    analogWrite(led5, 0);
  }

  if (leddiscoon == 1) {     // If led disco 'ON'
    analogWrite(led4, 255);
    delay(100);
    analogWrite(led4, 0);
    delay(50);    
    analogWrite(led2, 255);
    delay(100);
    analogWrite(led2, 0);
    delay(50);
    analogWrite(led3, 255);
    delay(100);
    analogWrite(led3, 0);
    delay(50);    
    analogWrite(led1, 255);
    delay(100);
    analogWrite(led1, 0);
    delay(50);
    analogWrite(led5, 255);
    delay(100);
    analogWrite(led5, 0);
    delay(50);
    aledon = 1;
  } 





  if (ledallon == 1) {     // If all led on = 1. Flash + fade each LED individually
    
    Serial.println("Led ALL ON");
    analogWrite(led1, 10);
    delay(50);
    analogWrite(led1, 0);
    delay(50);
    analogWrite(led1, 10);
    delay(45);
    analogWrite(led1, 50);
    delay(45);
    analogWrite(led1, 90);
    delay(45);
    analogWrite(led1, 120);
    delay(45);
    analogWrite(led1, 150);
    delay(45);
    analogWrite(led1, 180);
    delay(45);
    analogWrite(led1, 210);
    delay(45);
    analogWrite(led1, 240);
    delay(45);
    analogWrite(led1, 255);    
    delay(250);
/// end of LED 1
    analogWrite(led2, 10);
    delay(50);
    analogWrite(led2, 0);
    delay(50);
    analogWrite(led2, 10);
    delay(45);
    analogWrite(led2, 50);
    delay(45);
    analogWrite(led2, 90);
    delay(45);
    analogWrite(led2, 120);
    delay(45);
    analogWrite(led2, 150);
    delay(45);
    analogWrite(led2, 180);
    delay(45);
    analogWrite(led2, 210);
    delay(45);
    analogWrite(led2, 240);
    delay(45);
    analogWrite(led2, 255);    
    delay(250);
/// end of LED 2
    analogWrite(led3, 10);
    delay(50);
    analogWrite(led3, 0);
    delay(50);
    analogWrite(led3, 10);
    delay(45);
    analogWrite(led3, 50);
    delay(45);
    analogWrite(led3, 90);
    delay(45);
    analogWrite(led3, 120);
    delay(45);
    analogWrite(led3, 150);
    delay(45);
    analogWrite(led3, 180);
    delay(45);
    analogWrite(led3, 210);
    delay(45);
    analogWrite(led3, 240);
    delay(45);
    analogWrite(led3, 255);    
    delay(250);
/// end of LED 3
    analogWrite(led4, 10);
    delay(50);
    analogWrite(led4, 0);
    delay(50);
    analogWrite(led4, 10);
    delay(45);
    analogWrite(led4, 50);
    delay(45);
    analogWrite(led4, 90);
    delay(45);
    analogWrite(led4, 120);
    delay(45);
    analogWrite(led4, 150);
    delay(45);
    analogWrite(led4, 180);
    delay(45);
    analogWrite(led4, 210);
    delay(45);
    analogWrite(led4, 240);
    delay(45);
    analogWrite(led4, 255);    
    delay(250);
/// end of LED 4
    analogWrite(led5, 5);
    delay(45);
    analogWrite(led5, 10);
    delay(45);
    analogWrite(led5, 25);
    delay(45);
    analogWrite(led5, 50);
    delay(45);
    analogWrite(led5, 75);
    delay(45);
    analogWrite(led5, 100);
    delay(75);
    analogWrite(led5, 125);
    delay(95);
    analogWrite(led5, 150);
    delay(95);
    analogWrite(led5, 175);    
    delay(95);
    analogWrite(led5, 200);
    delay(95);
    analogWrite(led5, 225);
    delay(95);
    analogWrite(led5, 255);
/// end of LED 5   
    led1on = 1;
    led2on = 1;
    led3on = 1;
    led4on = 1;
    led5on = 1;
    brightness = 255;
    ledallon = 2;
    aledon = 1;
  }

  if (ledallon == 0) {     // If all led on = 0
    Serial.println("Led ALL OFF");
    analogWrite(led5, 255);
    delay(50);
    analogWrite(led5, 240);
    delay(45);
    analogWrite(led5, 210);
    delay(45);
    analogWrite(led5, 180);
    delay(45);
    analogWrite(led5, 150);
    delay(45);
    analogWrite(led5, 120);
    delay(45);
    analogWrite(led5, 90);
    delay(45);
    analogWrite(led5, 60);
    delay(45);
    analogWrite(led5, 30);
    delay(45);
    analogWrite(led5, 0);    
    delay(250);   
    // Led 5 off    
    analogWrite(led4, 255);
    delay(50);
    analogWrite(led4, 240);
    delay(45);
    analogWrite(led4, 210);
    delay(45);
    analogWrite(led4, 180);
    delay(45);
    analogWrite(led4, 150);
    delay(45);
    analogWrite(led4, 120);
    delay(45);
    analogWrite(led4, 90);
    delay(45);
    analogWrite(led4, 60);
    delay(45);
    analogWrite(led4, 30);
    delay(45);
    analogWrite(led4, 0);    
    delay(250);  
    // Led 4 off
    analogWrite(led3, 255);
    delay(50);
    analogWrite(led3, 240);
    delay(45);
    analogWrite(led3, 210);
    delay(45);
    analogWrite(led3, 180);
    delay(45);
    analogWrite(led3, 150);
    delay(45);
    analogWrite(led3, 120);
    delay(45);
    analogWrite(led3, 90);
    delay(45);
    analogWrite(led3, 60);
    delay(45);
    analogWrite(led3, 30);
    delay(45);
    analogWrite(led3, 0);    
    delay(250);    
    // Led 3 off

    analogWrite(led2, 255);
    delay(50);
    analogWrite(led2, 240);
    delay(45);
    analogWrite(led2, 210);
    delay(45);
    analogWrite(led2, 180);
    delay(45);
    analogWrite(led2, 150);
    delay(45);
    analogWrite(led2, 120);
    delay(45);
    analogWrite(led2, 90);
    delay(45);
    analogWrite(led2, 60);
    delay(45);
    analogWrite(led2, 30);
    delay(45);
    analogWrite(led2, 0);    
    delay(250);  
    
    // Led 2 off

    analogWrite(led1, 255);
    delay(50);
    analogWrite(led1, 240);
    delay(45);
    analogWrite(led1, 210);
    delay(45);
    analogWrite(led1, 180);
    delay(45);
    analogWrite(led1, 150);
    delay(45);
    analogWrite(led1, 120);
    delay(45);
    analogWrite(led1, 90);
    delay(45);
    analogWrite(led1, 60);
    delay(45);
    analogWrite(led1, 30);
    delay(45);
    analogWrite(led1, 0);     
    led1on = 0;
    led2on = 0;
    led3on = 0;
    led4on = 0;
    led5on = 0;
    leddiscoon = 0;
    ledallon = 3;
    aledon = 0;
  }



}/* --(end main loop )-- */


